/*
 * TRPCLatPubDataWrapper.h
 *
 *  Created on: Feb 6, 2024
 *      Author: yasmine
 */

#ifndef TRPCLATPubDataWrapper_WRAPPER_HEADER_H
#define TRPCLATPubDataWrapper_WRAPPER_HEADER_H

#include "pub/PubDataWrapper.h"
#include "dpc_trpc_lat/executable.h"


template<typename EventType>
class TRPCLat2CAN_PubDataWrapper: public PubDataWrapper<EventType> {

private:
	SWC2CAN _trpclat_to_can;
public:

    void GetData(ara::com::SampleAllocateePtr<EventType> &data) override{
        data->signal = _trpclat_to_can.signal;
        data->value = _trpclat_to_can.value;
        std::cout << "OOOOOOOOOOOOO PROCESS LAT PUB 2 CAN, Sig: " << +data->signal << " Val: " <<+data->value<< "\n";
    }

    void SetData(const SWC2CAN _trpclat_to_can_data)
	{
        _trpclat_to_can.signal = _trpclat_to_can_data.signal;
        _trpclat_to_can.value = _trpclat_to_can_data.value;
        std::cout << "OOOOOOOOOOOOO SET LAT PUB 2 CAN, Sig: " << +_trpclat_to_can.signal << " Val: "<<+_trpclat_to_can.value<< "\n";
	}

};
#endif /* TRPCLATPubDataWrapper_WRAPPER_HEADER_H */
